using System.Collections;
using System;
using System.Reflection;
using System.Collections.Generic;
using UnityEngine;

namespace Mod
{
    public class PrincessBloodSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => PrincessBlood.ID;
    }
    public class ShapeshifterBloodSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => ShapeshifterBlood.ID;
    }
    public class PrincessBlood : Liquid
    {   
        public const string ID = "PRINCESS BLOOD";
        public override string GetDisplayName() => "Princess blood";

        public PrincessBlood()
        {
            Color = new UnityEngine.Color(1f, 0.47f, 0.8f);
        }
        public override void OnEnterLimb(LimbBehaviour limb){}
        public override void OnUpdate(BloodContainer container)
        {
            base.OnUpdate(container); 

            if (container is CirculationBehaviour circ)
            {
                var limb = circ.Limb;
                if(!limb.transform.root.gameObject.HasComponent<shapeshifter>()){
                    shapeshifter sshifter=limb.Person.gameObject.GetOrAddComponent<shapeshifter>();
                    sshifter.NoInit=true;
                }
            }
        }
        public override void OnEnterContainer(BloodContainer container){}
        public override void OnExitContainer(BloodContainer container){}
    }
    public class ShapeshifterBlood : Liquid
    {
        public const string ID = "SHAPESHIFTER BLOOD";
        public override string GetDisplayName() => "Shapeshifter blood";

        public ShapeshifterBlood()
        {
            Color = new UnityEngine.Color(0.5f, 0.15f, 0.15f);
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
            if(!limb.gameObject.HasComponent<shapeshifting>()){
                limb.Person.gameObject.GetOrAddComponent<Waiting>();
            }
        }
        public override void OnUpdate(BloodContainer container){}
        public override void OnEnterContainer(BloodContainer container){}
        public override void OnExitContainer(BloodContainer container){}
    }
    public class Waiting : MonoBehaviour
    {
        public bool waiting=true;
        private void Update() {
            if(!waiting){
                shapeshifter sshifter=this.gameObject.GetOrAddComponent<shapeshifter>();
                sshifter.NoInit=true;
                sshifter.pupa=true;
                Destroy(this.GetComponent<Waiting>());
            }
            if(this.gameObject.HasComponent<shapeshifter>()){
                Destroy(this.GetComponent<Waiting>());
            }
        }
    }
}