using System.Collections;
using System;
using System.Collections.Generic;
using UnityEngine;
using System.Reflection;


namespace Mod
{       
    public struct  SpriteAssets
    {
        public static Texture2D PupaTex;
        public static Texture2D PrincessTex;
        public static Texture2D DroneTex;
    }
    public class Mod : MonoBehaviour
    {
        public static string ModTag = "Shapeshifter-"; 

        public static void Main()
        {
             SpriteAssets.PupaTex=ModAPI.LoadTexture("pupa.png");
             SpriteAssets.PrincessTex=ModAPI.LoadTexture("flesh_princess.png");
             SpriteAssets.DroneTex=ModAPI.LoadTexture("flesh_drone.png");

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"), 
                    NameOverride = ModTag+"Shapeshifter", 
                    DescriptionOverride = "It can steal power and skin from others by touching them. This even works for mod characters too!",
                    CategoryOverride = ModAPI.FindCategory("Entities"), 
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/ShapeShifter.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.gameObject.GetOrAddComponent<shapeshifter>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Signal Flare"), 
                    NameOverride = ModTag+"Drone Pheromone Releaser", 
                    DescriptionOverride = "Pheromone Releaser, might have some effects on shapeshifters?", 
                    CategoryOverride = ModAPI.FindCategory("Chemistry"), 
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/Pheromone Releaser.png"), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Pheromone Releaser.png",2); 
                        Instance.transform.localScale*=0.75f;
                        Instance.FixColliders();
                        Destroy(Instance.gameObject.GetComponent<FlareBehaviour>().FlareTopSprite);
                        Destroy(Instance.gameObject.GetComponent<FlareBehaviour>().FlareSystem);
                        Destroy(Instance.gameObject.GetComponent<FlareBehaviour>().TorchBehaviour);
                        
                        Pheromone P=Instance.AddComponent<Pheromone>();
                        P.PheromoneType="Drone";
                        P.enabled=false;

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            P.enabled=true;
                            Instance.gameObject.GetComponent<FlareBehaviour>().FlareTopSystem.Play();
                            Destroy(Instance.GetComponent<UseEventTrigger>());
                        };
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Signal Flare"), 
                    NameOverride = ModTag+"Princess Pheromone Releaser", 
                    DescriptionOverride = "Pheromone Releaser, might have some effects on shapeshifters?", 
                    CategoryOverride = ModAPI.FindCategory("Chemistry"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/Pheromone Releaser.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprites/Pheromone Releaser.png",2); 
                        Instance.transform.localScale*=0.75f;
                        Instance.FixColliders();
                        Destroy(Instance.gameObject.GetComponent<FlareBehaviour>().FlareTopSprite);
                        Destroy(Instance.gameObject.GetComponent<FlareBehaviour>().FlareSystem);
                        Destroy(Instance.gameObject.GetComponent<FlareBehaviour>().TorchBehaviour);
                        
                        Pheromone P=Instance.AddComponent<Pheromone>();
                        P.PheromoneType="Princess";
                        P.enabled=false;

                        Instance.AddComponent<UseEventTrigger>().Action = () =>
                        {
                            P.enabled=true;
                            Instance.gameObject.GetComponent<FlareBehaviour>().FlareTopSystem.Play();
                            Destroy(Instance.GetComponent<UseEventTrigger>());
                        };
                    }
                }
            );
            ModAPI.RegisterLiquid(PrincessBlood.ID, new PrincessBlood()); 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), 
                    NameOverride = ModTag+"Princess blood",
                    DescriptionOverride = "The blood of the princess, contagious, transforms the subject directly into a shapeshifter.",
                    CategoryOverride = ModAPI.FindCategory("Chemistry"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/PrincessBlood.png"),
                    AfterSpawn = (Instance) =>
                    {
                        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
                        Instance.GetOrAddComponent<PrincessBloodSyringe>();
                    }
                }
            );
            ModAPI.RegisterLiquid(ShapeshifterBlood.ID, new ShapeshifterBlood()); 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Acid Syringe"), 
                    NameOverride = ModTag+"Normal shapeshifter blood",
                    DescriptionOverride = "The blood of a normal shapeshifter, contagious, will not directly transform the subject into a shapeshifter, requiring pheromones to trigger the conversion.",
                    CategoryOverride = ModAPI.FindCategory("Chemistry"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/ShapeshifterBlood.png"),
                    AfterSpawn = (Instance) =>
                    {
                        UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
                        Instance.GetOrAddComponent<ShapeshifterBloodSyringe>();
                    }
                }
            );
        }
    }
}